% I_H = TRANSFORM_IMAGE_FORWARD(I,H) 
% takes an imput image I and a transformation matrix H and returns the 
% transformed image I_H computed by forward warping
%
% INPUT:    I   input gray value image
%           H   transformation matrix 3x3 (homogeneous coordinates)
%
% OUTPUT:   I_H   transformed image
%

function I_H = transform_image_forward(I,M)

% get sizes of image
[height, width, channels] = size(I);

% create output image of size 
I_H = zeros(size(I));

% go through all pixels of the input image I,
% compute the corresponding position in resulting image I_H,
% and write the corresponding intensity from I to I_H
for v = 1:height
    for u = 1:width        
        
        % compute position of pixel p=[u,v,1] (p from input image I) 
        % after application of transformation H by Hp=p'=[u',v',1] 
        % (p' in resulting image I_H)
        % (use homogeneous coordinates)
                
        % write the intensity of I(v,u) to I_H(v',u') 
        % (use only values inside the image domain)
        % think about why v and u are passed in the 
        % given order to the images
        
        fprintf('I do nothing yet!\n');
        
    end
end

% make sure that output has same data type as input image
I_H = cast(I_H,class(I));

return;